# Kling 3.0 Pro Text to Video API

> Filmiske klip på 3 til 15 sekunder fra en prompt med indbygget lyd og multi-shot-fortælling.

Klings flagskibsmodel til tekst-til-video gengiver jævne, fysisk plausible bevægelser og filmlignende belysning og genererer som standard matchende lyd og tale. Opdel ét klip i flere shots med prompts for hvert shot, eller lad modellen planlægge klippene selv. 16:9, 9:16 eller 1:1, enhver længde fra 3 til 15 sekunder, med en negativ prompt og en guidance-skala.

- Model id: `kling-video/v3/pro/text-to-video`
- Made by: Kling
- Category: Text to Video
- Output: video
- Price: from $0.112 / second (5 s ≈ $0.56) (cheapest run $0.56 (560 API credits))
- Run: `POST https://api.doitong.ru/v1/run/kling-video/v3/pro/text-to-video`
- Quote: `POST https://api.doitong.ru/v1/quote/kling-video/v3/pro/text-to-video`
- Docs page: https://doitong.com/da/developers/models/kling-video/v3/pro/text-to-video

## Pricing

Price: **from $0.112 / second (5 s ≈ $0.56)** (the lowest tier; the quote prices your exact input). Billed per second of output (`duration`, default 5).

Price rules (the first rule that matches the input wins; a parameter you leave out counts as its default):

- When `generate_audio` = true: $0.168 (168 API credits) / second

The full example input below costs $0.84 = 840 API credits (5 s × 168 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.ru/v1/quote/kling-video/v3/pro/text-to-video` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `prompt` |  | string \| null | no |  | ≤ 2500 characters | Tekstinstruktioner brugt til at generere videoen. Angiv præcis én af prompt eller multi_prompt. |
| `duration` |  | enum (string) | no | `5` | `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12`, `13`, `14`, `15` | Outputvideoens længde målt i sekunder. |
| `multi_prompt` |  | array of object {prompt, duration} \| null | no |  |  | Prompts og varigheder pr. optagelse, som erstatter den enkelte prompt for at oprette en video opdelt i flere optagelser. |
| `multi_prompt[].prompt` |  | string | yes |  |  | Tekstinstruktioner for den aktuelle optagelse. |
| `multi_prompt[].duration` |  | enum (string) | no | `5` | `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12`, `13`, `14`, `15` | Længden på den aktuelle optagelse målt i sekunder. |
| `generate_audio` |  | boolean | no | `true` |  | Skift til generering af indbygget videolyd, der understøtter stemmer på kinesisk eller engelsk og automatisk oversætter andre sprog til engelsk. Ved engelsk tale skal akronymer og egennavne skrives med store bogstaver og alt andet med små bogstaver. |
| `shot_type` |  | enum (string) | no | `customize` | `customize`, `intelligent` | Vælg, hvordan multi-shot-generering planlægger optagelserne; valg af 'intelligent' overlader optagelsesstrukturen til modellen. |
| `aspect_ratio` |  | enum (string) | no | `16:9` | `16:9`, `9:16`, `1:1` | Forholdet mellem bredde og højde for frames i outputvideoen. |
| `negative_prompt` |  | string | no | `blur, distort, and low quality` | ≤ 2500 characters |  |
| `cfg_scale` |  | number | no | `0.5` | 0 – 1 | Angiv, hvor tæt genereringen skal følge din prompt med CFG, forkortelse for Classifier Free Guidance. |

## Example input

Required parameters only:

```json
{}
```

A fuller example:

```json
{
  "prompt": "Close-up of fireflies dancing in a dark forest at twilight, soft glowing particles, slow dolly forward",
  "duration": 5,
  "aspect_ratio": "16:9"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.ru/v1/run/kling-video/v3/pro/text-to-video?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": "Close-up of fireflies dancing in a dark forest at twilight, soft glowing particles, slow dolly forward",
    "duration": 5,
    "aspect_ratio": "16:9"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.ru/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.ru/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/kling-video/v3/pro/text-to-video?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": "Close-up of fireflies dancing in a dark forest at twilight, soft glowing particles, slow dolly forward",
    "duration": 5,
    "aspect_ratio": "16:9"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.ru/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "Close-up of fireflies dancing in a dark forest at twilight, soft glowing particles, slow dolly forward",
    "duration": 5,
    "aspect_ratio": "16:9",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/kling-video/v3/pro/text-to-video", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.ru/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "kling-video/v3/pro/text-to-video",
      "input": {
        "prompt": "Close-up of fireflies dancing in a dark forest at twilight, soft glowing particles, slow dolly forward",
        "duration": 5,
        "aspect_ratio": "16:9"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "kling-video/v3/pro/text-to-video",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 840,
    "usd": "0.84",
    "charged": 840,
    "refunded": 0
  },
  "input": {
    "prompt": "Close-up of fireflies dancing in a dark forest at twilight, soft glowing particles, slow dolly forward",
    "duration": 5,
    "aspect_ratio": "16:9"
  },
  "output": {
    "video": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_name": "0-output.mp4",
      "file_size": 1843200
    }
  },
  "outputs": [
    {
      "type": "video",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_size": 1843200,
      "width": 1280,
      "height": 720,
      "duration": 5,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `video` | object {url, content_type, file_name, file_size} | Video produceret af modellen. |

## Related models

- [Kling Video V3 Text to Video 4K](https://doitong.com/developers/models/kling-video/v3/4k/text-to-video.md) (`kling-video/v3/4k/text-to-video`): $0.42 / second
- [Kling Video v3 Text to Video \[Standard\]](https://doitong.com/developers/models/kling-video/v3/standard/text-to-video.md) (`kling-video/v3/standard/text-to-video`): from $0.084 / second
- [Kling 3.0 Pro Image to Video](https://doitong.com/developers/models/kling-video/v3/pro/image-to-video.md) (`kling-video/v3/pro/image-to-video`): from $0.112 / second
- [Kling Video v3 Image to Video \[Standard\]](https://doitong.com/developers/models/kling-video/v3/standard/image-to-video.md) (`kling-video/v3/standard/image-to-video`): from $0.084 / second
- [Kling Video · v3 · 4k · Image to Video](https://doitong.com/developers/models/kling-video/v3/4k/image-to-video.md) (`kling-video/v3/4k/image-to-video`): $0.42 / second
- [FLUX 3 Max Text to Video](https://doitong.com/developers/models/blackforestlabs/flux-3-max/text-to-video.md) (`blackforestlabs/flux-3-max/text-to-video`): from $0.0425 / second of output video
- [Grok Imagine Video 1.5 Text to Video](https://doitong.com/developers/models/xai/grok-imagine-video/v1.5/text-to-video.md) (`xai/grok-imagine-video/v1.5/text-to-video`): from $0.08 / second
- [LTX 2.5 Pro Text to Video](https://doitong.com/developers/models/lightricks/ltx-2.5/text-to-video/pro.md) (`lightricks/ltx-2.5/text-to-video/pro`): from $0.12 / second

## Links

- HTML page: https://doitong.com/developers/models/kling-video/v3/pro/text-to-video
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=kling-video/v3/pro/text-to-video
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.ru/v1/models/kling-video/v3/pro/text-to-video
